version: "3.8"

services:

  zipkin:
    image: openzipkin/zipkin
    mem_limit: 700m
    ports:
      - "9411:9411"
    networks:
      - eazybank

  config-server:
    image: aqilzeka/config-server:latest
    mem_limit: 700m
    ports:
      - "8071:8071"
    networks:
      - eazybank
    depends_on:
      - zipkin
    environment:
      SPRING_PROFILES_ACTIVE: dev
      SPRING_ZIPKIN_BASEURL: http://zipkin:9411/

  eureka-server:
    image: aqilzeka/eureka-server:latest
    mem_limit: 700m
    ports:
      - "8070:8070"
    networks:
      - eazybank
    depends_on:
      - config-server
    deploy:
      restart_policy:
        condition: on-failure
        delay: 15s
        max_attempts: 3
        window: 120s
    environment:
      SPRING_PROFILES_ACTIVE: dev
      SPRING_CONFIG_IMPORT: configserver:http://config-server:8071/
      SPRING_ZIPKIN_BASEURL: http://zipkin:9411/


  accounts:
    image: aqilzeka/account-ms:latest
    mem_limit: 700m
    ports:
      - "8080:8080"
    networks:
      - eazybank
    depends_on:
      - config-server
      - eureka-server
    deploy:
      restart_policy:
        condition: on-failure
        delay: 30s
        max_attempts: 3
        window: 120s
    environment:
      SPRING_PROFILES_ACTIVE: dev
      SPRING_CONFIG_IMPORT: configserver:http://config-server:8071/
      EUREKA_CLIENT_SERVICEURL_DEFAULTZONE: http://eureka-server:8070/eureka/
      SPRING_ZIPKIN_BASEURL: http://zipkin:9411/


  loans:
    image: aqilzeka/loan-ms:latest
    mem_limit: 700m
    ports:
      - "8090:8090"
    networks:
      - eazybank
    depends_on:
      - config-server
      - eureka-server
    deploy:
      restart_policy:
        condition: on-failure
        delay: 30s
        max_attempts: 3
        window: 120s
    environment:
      SPRING_PROFILES_ACTIVE: dev
      SPRING_CONFIG_IMPORT: configserver:http://config-server:8071/
      EUREKA_CLIENT_SERVICEURL_DEFAULTZONE: http://eureka-server:8070/eureka/
      SPRING_ZIPKIN_BASEURL: http://zipkin:9411/


  cards:
    image: aqilzeka/card-ms:latest
    mem_limit: 700m
    ports:
      - "9000:9000"
    networks:
      - eazybank
    depends_on:
      - config-server
      - eureka-server
    deploy:
      restart_policy:
        condition: on-failure
        delay: 30s
        max_attempts: 3
        window: 120s
    environment:
      SPRING_PROFILES_ACTIVE: dev
      SPRING_CONFIG_IMPORT: configserver:http://config-server:8071/
      EUREKA_CLIENT_SERVICEURL_DEFAULTZONE: http://eureka-server:8070/eureka/
      SPRING_ZIPKIN_BASEURL: http://zipkin:9411/


  gateway-server:
    image: aqilzeka/gateway-server:latest
    mem_limit: 700m
    ports:
      - "8072:8072"
    networks:
      - eazybank
    depends_on:
      - config-server
      - eureka-server
      - cards
      - loans
      - accounts
    deploy:
      restart_policy:
        condition: on-failure
        delay: 45s
        max_attempts: 3
        window: 180s
    environment:
      SPRING_PROFILES_ACTIVE: dev
      SPRING_CONFIG_IMPORT: configserver:http://config-server:8071/
      EUREKA_CLIENT_SERVICEURL_DEFAULTZONE: http://eureka-server:8070/eureka/
      SPRING_ZIPKIN_BASEURL: http://zipkin:9411/


networks:
  eazybank: